//---------------------------------------------------------------------------
// Conversion from C++ TMMTimer Class
// TMMTimer Class - TMMTimer encapsulates the Windows Multimedia timer functions.
//   Author      : Wu, Chin-chia
//   Begin       : Jun 11, 2004
//   Last modify : Jun 22, 2004
//   Delphi Conversion by Chris Shieh
//
// NOTE :
//
//
//---------------------------------------------------------------------------

unit TMMTimerUnit;

interface

uses Windows, SysUtils, MMSystem, Messages, Classes, ExtCtrls;

Type
  TMMTimer = Class(TComponent)
  private
    // data members
    FTImerID:   UINT;       // hCpɾ I
    FEnabled:   Boolean;       // pɾҰʺX
    FInterval:  UINT;       // pɾĲojɶ (ms)
    FResolution:UINT;       // ~tѪR (ms)
    FTimeCaps:  TIMECAPS;   // hCpɾѪR׽d
    pFTimeCaps: PTimeCaps;
    FOnTimer: TNotifyEvent;
    // member functions
    // Ұ/hCpɾ
    procedure SetEnabled(Value: Boolean);
    // ]whCpɾѪR
    procedure SetResolution(Value:UINT);
    procedure SetOnTimer(Value: TNotifyEvent);
  public
    // constructor and destructor
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property Enabled: Boolean read FEnabled write SetEnabled;
    property Resolution:UINT read FResolution write SetResolution;
    property Interval:UINT read FInterval write FInterval;
    property TimeCaps:TIMECAPS read FTimeCaps;
    property OnTimer: TNotifyEvent read FOnTimer write SetOnTimer;
end;

  PTMMTimer = ^TMMTimer;

const
  ERRTITLE = 'TMMTimer Error';
  ERRMSG : array [0..2] of string =
          ('fails to return the timer device capabilities,',
           'resolution specified in FResolution is out of range',
           'fails to create timer event');

  procedure TimerProc(uTimerID, uMessage: UINT; dwUser, dw1, dw2: DWORD) stdcall;
  procedure Register;

implementation


uses Unit1;


//---------------------------------------------------------------------------
// TIMECALLBACK function
procedure TimerProc(uTimerID, uMessage: UINT; dwUser, dw1, dw2: DWORD) stdcall;
var
  pttimer:PTMMTimer;
begin
  // PTMMTimer(dwUser)dwUser^ӪA, b^ Өoe
  //pttimer := PTMMTimer(dwUser); //not work with Cardinal(@self)
  // IsϥΪ̩wq禡
  //pttimer^.FOnTimer(nil);//not work

  // IsϥΪ̩wq禡
  TMMTimer(dwUser).FOnTimer(nil); //work!! with Cardinal(self)
end;


//---------------------------------------------------------------------------
// غcl
constructor TMMTimer.Create(AOwner: TComponent);
begin
  FTImerID:=0;
  FEnabled:= false;
  FResolution:= 5;
  FInterval:= 1000;
  pFTimeCaps:=@FTimeCaps;
  // ohCpɾѪR
  if not (timeGetDevCaps(pFTimeCaps, Sizeof(FTimeCaps)) = TIMERR_NOERROR) then
    MessageBox(0, PChar(ERRMSG[0]), PChar(ERRTITLE), MB_OK);
  // ]whCpɾѪR׬ FResolution
  if not (timeBeginPeriod(FResolution) = TIMERR_NOERROR) then
    MessageBox(0, PChar(ERRMSG[1]), PChar(ERRTITLE), MB_OK);

  inherited;
end;

//---------------------------------------------------------------------------
// Ѻcl
destructor TMMTimer.Destroy;
begin
  SetEnabled(false);
  // ٭hCpɾѪR
  if not (timeEndPeriod(FResolution) = TIMERR_NOERROR) then
    MessageBox(0, PChar(ERRMSG[1]), PChar(ERRTITLE), MB_OK);

  inherited;
end;

//---------------------------------------------------------------------------
// Ұ/hCpɾ
procedure TMMTimer.SetEnabled(value:Boolean);
begin
  // Ұ
  if (value) then
  begin
    if (FTImerID = 0) then
    begin
      // ]whCpɾAopɾID
      // FѨMcallback functionIsmember functionsD
      // NclassmzLdwUserѼƶǵcallback function
      FTImerID := timeSetEvent(FInterval,      // Ĳojɶ(ms)
                              FResolution,    // eԸѪR׮ɶ(ms)
                              TimerProc,      // ^I禡(callback function)}
                              Cardinal(self),  // ϥΪ̩wqơAǵcallback functiondwUserѼ
                              TIME_PERIODIC); // Ĳo覡GgĲo

      if (FTImerID = 0) then  MessageBox(0, PChar(ERRMSG[2]), ERRTITLE, MB_OK);
      FEnabled := true;
    end;
  end
  // 
  else
  begin
    // RhCpɾ
    timeKillEvent(FTImerID);
    FTImerID := 0;
    FEnabled := false;
  end;
end;

             
procedure TMMTimer.SetResolution(value:UINT);
begin
  // ٭hCpɾѪR
  if not (timeEndPeriod(FResolution) = TIMERR_NOERROR) then
    MessageBox(0, PChar(ERRMSG[1]), ERRTITLE, MB_OK);
  // վѪRרϦbhCpɾ\d
  if (value < FTimeCaps.wPeriodMin) then
    FResolution := FTimeCaps.wPeriodMin
  else if (value > FTimeCaps.wPeriodMax) then
    FResolution := FTimeCaps.wPeriodMax;
  // ]whCpɾѪR
  if not (timeBeginPeriod(FResolution) = TIMERR_NOERROR) then
    MessageBox(0, PChar(ERRMSG[1]), ERRTITLE, MB_OK);
end;

procedure TMMTimer.SetOnTimer(Value: TNotifyEvent);
begin
  FOnTimer := Value;
end;



procedure Register;
begin
  RegisterComponents('System', [TMMTimer]);
end;

end.
