unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, ExtCtrls, TMMTimerUnit;

type
  TForm1 = class(TForm)
    Button1: TButton;
    Label1: TLabel;
    Timer1: TTimer;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Image1: TPaintBox;
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    MMTimer: TMMTimer;
    bg: TBitmap;
    SourceRect, DestRect: TRect;
    { Private declarations }
  public
    { Public declarations }
  end;


var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  self.DoubleBuffered := True;

  MMTimer := TMMTimer.Create(self);
  MMTimer.OnTimer := Timer1Timer;
  MMTimer.Resolution := 1;
  MMTimer.Interval := 10;

  bg := TBitmap.Create;
  bg.LoadFromFile('BG.bmp');

  SourceRect.Left := 0;
  SourceRect.Top := 0;
  SourceRect.Right := 800;
  SourceRect.Bottom := 356;
  DestRect.Left := 0;
  DestRect.Top := 0;
  DestRect.Right := 800;
  DestRect.Bottom := 356;

  Image1.Canvas.CopyRect(DestRect, BG.Canvas, SourceRect);
  Label1.Caption := Format('SourceRect.Left = %d', [SourceRect.Left]);

end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if (SourceRect.Left < BG.Width - 800) then
  begin
    Inc(SourceRect.Left);
    Inc(SourceRect.Right);
  end
  else
  begin
    SourceRect.Left := 0;
    SourceRect.Right := 800;
  end;

  Image1.Canvas.CopyRect(DestRect, BG.Canvas, SourceRect);
  Label1.Caption := Format('SourceRect.Left = %d', [SourceRect.Left]);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  if RadioButton1.Checked then
  begin
    if (not Timer1.Enabled) then
    begin
      Button1.Caption := 'STOP';
      Timer1.Enabled := true;
    end
    else
    begin
      Button1.Caption := 'START';
      Timer1.Enabled := false;
    end;
  end
  else
  if RadioButton2.Checked then
  begin
    if (not MMTimer.Enabled) then
    begin
      Button1.Caption := 'STOP';
      MMTimer.Enabled := true;
    end
    else
    begin
      Button1.Caption := 'START';
      MMTimer.Enabled := false;
    end;
  end;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  if Assigned(MMTimer) then
    FreeAndNil(MMTimer);
end;

end.

